package com.logicbig.example;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Version;

@Entity
public class Phone {
    @Id
    @GeneratedValue
    private int id;
    @Version
    private long version;
    private String number;
    private String type;

    public Phone() {
    }

    public Phone(String number, String type) {
        this.number = number;
        this.type = type;
    }

    public static Phone cell(String number) {
        return new Phone(number, "cell");
    }

    public static Phone work(String number) {
        return new Phone(number, "work");
    }

    public static Phone home(String number) {
        return new Phone(number, "home");
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }


    @Override
    public String toString() {
        return "Phone{" +
                "id=" + id +
                ", version=" + version +
                ", number='" + number + '\'' +
                ", type='" + type + '\'' +
                '}';
    }
}