package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class UpdatingRelationExample2 {
    private static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            persistEmployee();
            addNewPhone1();
            addNewPhone2();
            loadEmployee();
        } finally {
            entityManagerFactory.close();
        }
    }

    private static void addNewPhone1() {
        System.out.println("Update 1 starts, adding new phone number for the employee");
        EntityManager em = entityManagerFactory.createEntityManager();
        Employee employee = em.find(Employee.class, 1L);
        em.getTransaction().begin();
        employee.getPhones().add(Phone.work("222-222-2222"));
        em.getTransaction().commit();
        em.close();
        System.out.println("Employee updated 1: " + employee);
    }

    private static void addNewPhone2() {
        System.out.println("Update 2 starts, adding another new phone number for the employee");
        EntityManager em = entityManagerFactory.createEntityManager();
        Employee employee = em.find(Employee.class, 1L);
        em.getTransaction().begin();
        employee.getPhones().add(Phone.home("333-333-3333"));
        em.getTransaction().commit();
        em.close();
        System.out.println("Employee updated 2: " + employee);
    }

    private static void loadEmployee() {
        EntityManager em = entityManagerFactory.createEntityManager();
        Employee employee = em.find(Employee.class, 1L);
        System.out.println("Employee loaded: " + employee);
    }

    public static void persistEmployee() {
        Employee employee = new Employee("Joe",
                "IT", Phone.cell("111-111-1111"));
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(employee);
        em.getTransaction().commit();
        em.close();
        System.out.println("Employee persisted: " + employee);
    }
}